# -*- coding: utf-8 -*-
# Project : flacon
# File : flaconglobal.py
# (c) Alexander Sokolov asokol@mail.ru
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 3
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.


import exceptions
import subprocess
import os

from PyQt4 import QtCore
from PyQt4.QtCore import *


class AudioFormat:
    UNKNOWN     = ''
    WAV         = 'WAV'
    FLAC        = 'FLAC'
    OGG         = 'OGG'
    MP3         = 'MP3'
    WV          = 'WV'
    APE         = 'APE'
    TTA         = 'TTA'


class Statuses:
    NotRunning  = 0
    Error       = 1
    Aborted     = 2
    OK          = 3
    Extracting  = 4
    Encoding    = 5
    Queued      = 6
    WaitGain    = 7
    CalcGain    = 8
    WriteGain   = 9


class ReplayGainTypes:
    Disable     = 'Disable'
    Track       = 'Track'
    Album       = 'Album'



#****************************************************************
#
#****************************************************************
def tryPopen(args, bufsize=0, executable=None, stdin=None, stdout=None, stderr=None, preexec_fn=None, close_fds=False,
                shell=False, cwd=None, env=None, universal_newlines=False, startupinfo=None, creationflags=0 ):

    if isinstance(args, QStringList):
        _args = []
        for s in args:
            _args.append(unicode(s))
    else:
        _args = args

    try:
        return subprocess.Popen(_args, bufsize, executable, stdin, stdout, stderr, preexec_fn, close_fds,
                     shell, cwd, env, universal_newlines, startupinfo, creationflags)
    except OSError, e:
        exceptions = QObject()
        raise Exception(unicode(exceptions.tr('Program "%1" not found.').arg(QString(args[0]))))



#****************************************************************
#
#****************************************************************
def pipeToQString(pipe):
    codec = QTextCodec.codecForLocale()
    lines = QStringList()
    for line in pipe:
        lines << codec.toUnicode(line)

    return lines.join("\n")


#****************************************************************
#
#****************************************************************
def pipeToStr(pipe):
    return unicode(pipeToQString(pipe))


#****************************************************************
#
#****************************************************************
def modulesDir():
    return os.path.dirname(__file__)


